﻿function RSSMiniReader(dom_element,url_feed,item_count) {
	var _this = this;
	this.dom = dom_element;
	this.url = url_feed;
	this.itemCount = item_count ? item_count : 3;
	this._reImg = new RegExp("<im([^>].*?)src\s*=\s*[\"'](.*?)[\"']","mi");
	this.RSSMiniReaderInit();
}

RSSMiniReader.prototype.RSSMiniReaderInit = function() {
	this.RSSMRCreateMainContainer();
	this.RSSMRWaiting()
	this.RSSMRGetFeed();
}

RSSMiniReader.prototype.RSSMRCreateMainContainer = function() {
	// Append and get main container DIV
	var main_container  = '<div class="RSSMiniReader"></div>';
	jQuery('#' + this.dom).append(main_container);
	this._domRssReader = jQuery('#' + this.dom + ' .RSSMiniReader');
	this._backgroundcolor = jQuery(this._domRssReader).css('background-color');
	// Set Title container
	html 	= '<div class="RSSTitleContainer"><div class="RSSTitle"></div></div>';
	jQuery(this._domRssReader).append(html);
}

RSSMiniReader.prototype.RSSMRWaiting = function() {
	this._domRssReader.find('.RSSTitle').html("Waiting for feed...")
		.corner("tr tl dog 10px");
}

RSSMiniReader.prototype.RSSMRGetFeed = function() {
	var _this = this;
	jQuery.getFeed({
        url: this.url,
        success: function(feed) {_this.createRSSHtml(feed)}
    });
}

RSSMiniReader.prototype.createRSSHtml = function(feed) {
	// Set Title
	var title = feed.title.truncateWithDots(29);
	var title_link = '<a target="_blank" href="' + feed.link +
		'">'+ title + '</a>';
	this._domRssReader.find('.RSSTitle').html(title_link);
	for(var i = 0; i < feed.items.length && i < this.itemCount; i++) {
		var item = feed.items[i];
		var title_item = item.title.truncateWithDots(32);
		html = '<div class="RSSItem">';
		// Titolo della notizia
		html += '<div class="RSSItemTitle"><a href="' +
			item.link + '">' + title_item +'</a></div>';
		// Contenuto della notizia
		var item_descr = item.description.stripTags();
		item_descr = item_descr.truncateWithDots(250);
		html += '<div class="RSSItemText">' + item_descr  + '</div>';
		
		//Clear
		html += '<div class="RSSItemClear"> </div>';
		
		// End RSSItem
		html += '</div>';				
		jQuery(this._domRssReader).append(html);

		domItem = jQuery('#' + this.dom + " .RSSMiniReader .RSSItem:last");
		this.RSSMRAddItemImage(domItem,item);
		domItem.fadeIn("slow");
		this.RSSMRItemLayoutSetup(domItem);
	}
	this.RSSMRLayoutSetup(this._domRssReader);	
}

RSSMiniReader.prototype.RSSMRItemLayoutSetup = function(domItem) {
   domItem.corner("cc:" + this._backgroundcolor + " 20px");
}

RSSMiniReader.prototype.RSSMRLayoutSetup = function(domRssReader) {
   domRssReader.corner("bl br dog 10px")
	 	.find('.RSSTitle').corner("tr tl dog 10px");
}

RSSMiniReader.prototype.RSSMRAddItemImage = function(domItem,item) {
		// Gestione dell'immagine
		// Estraggo il primo tag IMG dalla descrizione
		var arrImg = this._reImg.exec(item.description);
		if (arrImg) {
			// Image found in feed
			var firstImgLink = arrImg[2];		

			var imgObj = new Image();
			// Next two link to avoid IE onload problem
			imgObj.hasLoaded = false;
			imgObj.itemImageLoaded = itemImageLoaded;
			imgObj.onload = itemImageLoaded;
			imgObj.domItem = domItem;
			imgObj.itemLink = item.link;
			imgObj.src = firstImgLink;
			// Direct call to onload handler for IE problem
			imgObj.itemImageLoaded();
		}
}

function itemImageLoaded() {
	if (this.hasLoaded) return;
	if (this.height > 10 && this.width > 10) {
		this.hasLoaded = true;
		var width = 60;
		scaleWidth = this.width / width;
		var height = Math.round(this.height / scaleWidth);
		html = '<div class="RSSItemImage"><a href="' +
			this.itemLink + '"><img src="' +
			this.src + '" width="' + width + '" height="' + height +
			'" /></a></div>';
		this.domItem.find('.RSSItemTitle').after(html);
	}
}

if (String.prototype.stripTags==null) 
	String.prototype.stripTags = function() {
        return this.replace(/<\/?[^>]+>/gi, '');
};

if (String.prototype.truncateWithDots==null) 
	String.prototype.truncateWithDots = function(length) {
        return this.length > length
			? this.substring(0,length) + '...'
			: this;
};
